<?php
#!/usr/local/bin/php

//鍋田辞書ランダム PHP版 Ver 1.0 (C)
//鍋田辞書CGIデータからランダムに単語を選んで、単語と訳を返します。
//辞書データは鍋田辞書Windows版で作成したものを使います。
//用途として、HTML内にランダムで選んだ単語と訳を埋め込んだり、別途用意したツイッター送信スクリプトに渡してツイッターにポストするなどの用途が考えられます。
//著作権は、無断での再配布禁止にしますがその他は自由、無料です。
//http://www.nabeta.tk

#データ認識コード
#間違って他のデータを検索しないための鍋田辞書CGIデータという印
$data_version_code = 654018739;

$syouryaku = "(省略)...";

//例えば、タイ日と、日タイが混ざっている辞書で、
//タイ日のみをランダムで選ぶために文字の言語をチェックする。
//$gengo== 0: 文字言語チェック無し
//$gengo== 1: 日本語以外(単語が日本語以外のデータ利用)
//$gengo== 2: タイ語
//$gengo== 3: ラオス語
//$gengo== 4: カンボジア語
//$gengo== 5: ハングル、韓国朝鮮語
//$gengo== 6: 日本語(単語が日本語のデータ利用)
Function str_gengo_check($utf8,$gengo)
{
  if($gengo == 0){
    //言語指定が無い場合、常にOKを返す
    return 9999;
  }
  $ucs2s = iconv('UTF-8', 'UCS-4LE', $utf8); // UTF-8 to UCS4
  $ucs2b = str_split($ucs2s,1);
  $len = count($ucs2b)/4;
  for($i = 0;$i<$len;$i++){
    $wc = 0;
    $tmp1 = ord($ucs2b[$i*4]);
    $tmp2 = ord($ucs2b[$i*4+1]);
    $tmp3 = ord($ucs2b[$i*4+2]);
    $tmp4 = ord($ucs2b[$i*4+3]);

    $wc = $tmp1 + ($tmp2 * 0x100) + ($tmp3 * 0x10000) + ($tmp4 * 0x1000000);

    //printf("%x , ",$wc);
    if($gengo == 1){
      //日本語以外かどうかチェック
      //日本語文字(中国語と区別つかない)
      if(($wc >= 0x2eb0 && $wc <= 0x30ff) ||
        ($wc >= 0x31c0 && $wc <= 0x9fff) ||
        ($wc >= 0xf900 && $wc <= 0xfaff) ||
        ($wc >= 0xfe30 && $wc <= 0xfe4f) ||
        ($wc >= 0x20000 && $wc <= 0x2fa1f)){
        //日本語の場合、日本語がある場合、NG
        return -1;
      }
    }
    else
    if($gengo == 2){
      //タイ語文字チェック
      if($wc >= 0xe00 && $wc <= 0xe7f){
        //タイ語文字有り
        return $gengo;
      }
    }
    else
    if($gengo == 3){
      //ラオス語文字チェック
      if($wc >= 0xe80 && $wc <= 0xeff){
        //ラオス語文字有り
        return $gengo;
      }
    }
    else
    if($gengo == 4){
      //カンボジア語文字チェック
      if(($wc >= 0x1780 && $wc <= 0x17ff) ||
        ($wc >= 0x19e0 && $wc <= 0x19ff)){
        //カンボジア語文字有り
        return $gengo;
      }
    }
    else
    if($gengo == 5){
      //ハングル、韓国語朝鮮語文字チェック
      if($wc >= 0xac00 && $wc <= 0xd7ff){
        //ハングル文字有り
        return $gengo;
      }
    }
    else
    if($gengo == 6){
      //日本語かどうかチェック
      //日本語文字(中国語と区別つかない)
      if(($wc >= 0x2eb0 && $wc <= 0x30ff) ||
        ($wc >= 0x31c0 && $wc <= 0x9fff) ||
        ($wc >= 0xf900 && $wc <= 0xfaff) ||
        ($wc >= 0xfe30 && $wc <= 0xfe4f) ||
        ($wc >= 0x20000 && $wc <= 0x2fa1f)){
        return $gengo;
      }
    }
  }
  if($gengo == 1){
    //日本語以外の場合は、日本語が無い場合OK
    return $gengo;
  }
  return -1;
}

Function yakugo_cut_syori_br($yakugo_str,$yakugo_cut_size)
{
    global $syouryaku;
    $len = strlen($yakugo_str);
    if($len < $yakugo_cut_size){
      return $yakugo_str;
    }
    $a = strpos($yakugo_str,"<br>",1);
    # ==の二個ではなく、===の三個を使う。
    #二個でもエラーにはならないが期待した動作をしない。
    if($a === false || $a == ""){
      #見つからない
    }
    else{
      if($a > $yakugo_cut_size){
        $yakugo_str = substr($yakugo_str,0,$a);
        $yakugo_str .= $syouryaku;
      }
      else{
        $a2 = strpos($yakugo_str,"<br>",$a+4); //$a+4
        if($a2 === false || $a2 == ""){
          #$yakugo_str = substr($yakugo_str,0,$a);
	}
	else{
          if($a2 > $yakugo_cut_size){
            $yakugo_str = substr($yakugo_str,0,$a2);
            $yakugo_str .= $syouryaku;
          }
	  else{
            if(1){//$mini_yaku_cut){}
              $mae = $a2 + 4;
              while(1){
                $a3 = strpos($yakugo_str,"<br>",$mae);
                if($a3 > $yakugo_cut_size){
                  $yakugo_str = substr($yakugo_str,0,$mae);
                  $yakugo_str .= $syouryaku;
                  break;
		}
	        if($a3 === 0 || $a3 == ""){
                  break;
	        }
                $mae = $a3+4;
	      }
            }
	    /*
	    else{
              $a3 = strpos($yakugo_str,"<br>",$a2+4);
	      if($a3 === 0 || $a3 == ""){
                #$yakugo_str = substr($yakugo_str,0,$a2);
	      }
	      else{
                $yakugo_str = substr($yakugo_str,0,$a3);
                $yakugo_str .= $syouryaku;
	      }
	    }
	     */
	  }
        }
      }
    }
  return $yakugo_str;
}

Function yakugo_cut_syori($yakugo_str,$yakugo_cut_size)
{
    global $syouryaku;
    $len = strlen($yakugo_str);
    if($len < $yakugo_cut_size){
      return $yakugo_str;
    }
    $a = strpos($yakugo_str,",",1);
    # ==の二個ではなく、===の三個を使う。
    #二個でもエラーにはならないが期待した動作をしない。
    if($a === false || $a == ""){
      #見つからない
    }
    else{
      if($a > $yakugo_cut_size){
        $yakugo_str = substr($yakugo_str,0,$a);
        $yakugo_str .= $syouryaku;
      }
      else{
        $a2 = strpos($yakugo_str,",",$a+1);
        if($a2 === false || $a2 == ""){
          #$yakugo_str = substr($yakugo_str,0,$a);
	}
	else{
          if($a2 > $yakugo_cut_size){
            $yakugo_str = substr($yakugo_str,0,$a2);
            $yakugo_str .= $syouryaku;
          }
	  else{
            if(1){//$mini_yaku_cut){}
              $mae = $a2 + 1;
              while(1){
                $a3 = strpos($yakugo_str,",",$mae);
                if($a3 > $yakugo_cut_size){
                  $yakugo_str = substr($yakugo_str,0,$mae);
                  $yakugo_str .= $syouryaku;
                  break;
		}
	        if($a3 === 0 || $a3 == ""){
                  break;
	        }
                $mae = $a3+1;
	      }
            }
	    /*
	    else{
              $a3 = strpos($yakugo_str,"<br>",$a2+4);
	      if($a3 === 0 || $a3 == ""){
                #$yakugo_str = substr($yakugo_str,0,$a2);
	      }
	      else{
                $yakugo_str = substr($yakugo_str,0,$a3);
                $yakugo_str .= $syouryaku;
	      }
	    }
	     */
	  }
        }
      }
    }
  return $yakugo_str;
}

Function yakugo_syori($yakugo_str,$twf,$yaku_cut,$yakugo_cut_size)
{
  global $sjisf;
  $htmlf = 0;
  if($sjisf){
    $yakugo_str = iconv('utf-8', 'cp932', $yakugo_str);
  }
  if(eregi("^[ 	\r\n]*<html>",$yakugo_str)){
    $htmlf = 1;
  }
  if($htmlf){
    $yakugo_str = eregi_replace("^[ 	\r\n]*<html>","",$yakugo_str);
    $yakugo_str = eregi_replace("<\/html>","",$yakugo_str);
    if($yaku_cut){
      $yakugo_str = yakugo_cut_syori_br($yakugo_str,$yakugo_cut_size);
    }
    if($twf){
      $yakugo_str = eregi_replace("<br>",",",$yakugo_str);
    }

    return $yakugo_str;
  }
  else
  if($twf == 0){
    $yakugo_str = str_replace("\r\n","<br>",$yakugo_str);
    $yakugo_str = str_replace("\n","<br>",$yakugo_str);
    $yakugo_str = str_replace("\r","<br>",$yakugo_str);
    if($yaku_cut){
      $yakugo_str = yakugo_cut_syori_br($yakugo_str,$yakugo_cut_size);
    }
  }
  else{
    $yakugo_str = str_replace("\r\n",",",$yakugo_str);
    $yakugo_str = str_replace("\n",",",$yakugo_str);
    $yakugo_str = str_replace("\r",",",$yakugo_str);
    if($yaku_cut){
      $yakugo_str = yakugo_cut_syori($yakugo_str,$yakugo_cut_size);
    }
  }
  return $yakugo_str;
}

Function hedda_yomikomi($file1)
{
    #先頭にシーク
    #fseek($DATA, 0);
    #ファイル識別子読み込み
    global $DATA;
    global $data_version_code;
    global $rec_suu;
    global $index_kaishi_ichi;
    global $data_kaishi_ichi;

    $buf = fread($DATA,4);
    /* if (sizeof($buf) != 4) {
        print("Read ERROR Index file\n");
        fclose($DATA); 
        exit(1);
    }*/
    $version_code = unpack("V",$buf);
    if($version_code[1] != $data_version_code){
      print("EROR $file1 is not Nabeta CGI data file\n");
      fclose($DATA); 
      exit(1);
    }

    #レコード数読み込み(データ数)(見出し数)
    $buf = fread($DATA,4);
    /* if(strlen($buf)!= 4) {
        print("Read ERROR Index file\n");
        fclose($DATA); 
        exit(1);
    }*/
    $tmp = unpack("V",$buf);
    $rec_suu = $tmp[1];
    if($rec_suu == 0){
      print("EROR Data size zero.$file1\n");
      fclose($DATA); 
      exit(1);
    }
    #インデックス開始位置数読み込み
    $buf = fread($DATA,4);
    /* if(sizeof($buf) != 4) {
        print("Read ERROR Index file\n");
        fclose($DATA); 
        exit(1);
    }*/
    $tmp = unpack("V",$buf);
    $index_kaishi_ichi = $tmp[1];
    if($index_kaishi_ichi == 0){
      print("EROR Data size zero.$file1\n");
      fclose($DATA); 
      exit(1);
    }

    #データ開始位置数読み込み
    $buf = fread($DATA,4);
    /* if(sizeof($buf) != 4) {
        print("Read ERROR Index file\n");
        fclose($DATA); 
        exit(1);
    }*/
    $tmp = unpack("V",$buf);
    $data_kaishi_ichi = $tmp[1];
    if($data_kaishi_ichi == 0){
      print("EROR Data size zero.$file1\n");
      fclose($DATA); 
      exit(1);
    }
}

$nabeta_s1 = array();
$nabeta_s2 = array();
$nabeta_s1len = 0;
$nabeta_s2len = 0;

#鍋田辞書独自のソート順の文字列比較のための文字列を数字配列に変換。
#文字列先頭の7ビットのアスキーコードだけ順番が違う。
#NULLが最も小さく次にa-z,A-Z,、その他の7ビットの記号、後は通常のUnicode順
#もし、データが他のソート順であればここを変更しないといけない
Function nabeta_str2s1($sin)
{
  #$tmp = unpack("C*",$sin);
  global $nabeta_s1;
  global $nabeta_s1len;
  $mscd_str = str_split($sin);
  #$len = sizeof($mscd_str);
  $len = strlen($sin);
  $nabeta_s1len = $len;
  for($i=0;$i<$len;++$i){
    $cc = ord($mscd_str[$i]);
    #$tmp = unpack("C",$mscd_str[$i]);これでもよい
    #$cc = $tmp[1];
    if($i != 0){
      $nabeta_s1[$i] = $cc;
    }
    else
    if($cc >= 0x80){
      $nabeta_s1[$i] = $cc;
    }
    else
    if($cc == 0){
      #あり得ないパターン
      $nabeta_s1[$i] = $cc;
    }
    else
    if($cc <= 0x40){
      #記号1
      #53=ローマ字小文字26+ローマ字大文字26+NULL
      $nabeta_s1[$i] = $cc + 52 + 1;
    }
    else
    if($cc <= 0x5a){
      #A-Z
      #A=0x41
      $nabeta_s1[$i] = $cc - 0x41 + 26 + 1;
    }
    else
    if($cc <= 0x60){
      #記号2
      #53=ローマ字小文字26+ローマ字大文字26+NULL1
      $nabeta_s1[$i] = $cc - 0x5b + 52 + 0x40 + 1;
    }
    else
    if($cc <= 0x7a){
     #a-z
     #a=0x61
      $nabeta_s1[$i] = $cc - 0x61 + 1;
    }
    else
    if($cc <= 0x7f){
      #記号2
      #53=ローマ字小文字26+ローマ字大文字26+NULL1
      $nabeta_s1[$i] = $cc - 0x7b + 52 + 0x46 + 1;
    }
  }
}

Function nabeta_str2s2($sin)
{
  global $nabeta_s2;
  global $nabeta_s2len;
  #$tmp = unpack("C*",$sin);
  $mscd_str = str_split($sin);
  #$len = sizeof($mscd_str);
  $len = strlen($sin);
  $nabeta_s2len = $len;
  for($i=0;$i<$len;++$i){
    $cc = ord($mscd_str[$i]);
    #$tmp = unpack("C",$mscd_str[$i]);これでもよい
    #$cc = $tmp[1];
    if($i != 0){
      $nabeta_s2[$i] = $cc;
    }
    else
    if($cc >= 0x80){
      $nabeta_s2[$i] = $cc;
    }
    else
    if($cc == 0){
      #あり得ないパターン
      $nabeta_s2[$i] = $cc;
    }
    else
    if($cc <= 0x40){
      #記号1
      #53=ローマ字小文字26+ローマ字大文字26+NULL
      $nabeta_s2[$i] = $cc + 52 + 1;
    }
    else
    if($cc <= 0x5a){
      #A-Z
      #A=0x41
      $nabeta_s2[$i] = $cc - 0x41 + 26 + 1;
    }
    else
    if($cc <= 0x60){
      #記号2
      #53=ローマ字小文字26+ローマ字大文字26+NULL1
      $nabeta_s2[$i] = $cc - 0x5b + 52 + 0x40 + 1;
    }
    else
    if($cc <= 0x7a){
     #a-z
     #a=0x61
      $nabeta_s2[$i] = $cc - 0x61 + 1;
    }
    else
    if($cc <= 0x7f){
      #記号2
      #53=ローマ字小文字26+ローマ字大文字26+NULL1
      $nabeta_s2[$i] = $cc - 0x7b + 52 + 0x46 + 1;
    }
  }
  #my $n_str = pack "C*", $mscd; パックできない
}



#文字列を鍋田辞書独自のソート順に変換した数値配列の大小を比較
Function nabeta_strcmp()
{
  global $nabeta_s1;
  global $nabeta_s2;
  global $nabeta_s1len;
  global $nabeta_s2len;
  $len1 = $nabeta_s1len;
  $len2 = $nabeta_s2len;


  if($len1 > $len2){
    $lenns = $len2;
  }
  else{
    $lenns = $len1;
  }
  for($i=0;$i < $lenns;++$i){
    if($nabeta_s1[$i] > $nabeta_s2[$i]){
      #s1,左が大きい
      return 1;
    }
    else
    if($nabeta_s1[$i] < $nabeta_s2[$i]){
      #s1,左が小さい
      return -1;
    }
  }

  if($len1 > $len2){
    #s1,左が大きい
    return 1;
  }
  else
  if($len1 < $len2){
    #s1,左が小さい
    return -1;
  }
  else{
    #同じ
    return 0;
  }
}


Function tango_yomikomi($rec_no)
{
    global $DATA;
    global $data_version_code;
    global $rec_suu;
    global $index_kaishi_ichi;
    global $data_kaishi_ichi;
    global $tangos;

    $tangos = "";
    $yakugo = "";
    if($rec_no >= $rec_suu){
      return;
    }
    fseek($DATA, $rec_no * 4 + $index_kaishi_ichi);
    $buf = fread($DATA,4);
    /* if(sizeof($buf) != 4) {
        print("Read ERROR Index file\n");
        fclose($DATA); 
        exit(1);
    }*/
    $tmp = unpack("V",$buf);
    $data_adr = $tmp[1];

    fseek($DATA, $data_adr + $data_kaishi_ichi);
    $tangos = "";
    while(1){
      $c = fgetc($DATA);
      if(strcmp($c,"\0")==0){
        break;   
      }       
      $tangos = $tangos . $c; 
    }
    return $tangos;

}

//$gengo= 0: 文字言語チェック無し
//$gengo= 1: 日本語以外(単語が日本語以外のデータ利用)
//$gengo= 2: タイ語(単語がタイ語のデータ利用)
//$gengo= 3: ラオス語(単語がラオス語のデータ利用)
//$gengo= 4: カンボジア語(単語がカンボジア語のデータ利用)
//$gengo= 5: ハングル、韓国朝鮮語(単語がハングルのデータ利用)
//$gengo= 6: 日本語(単語が日本語のデータ利用)
//単語の文字の言語を選ぶ時に0以外を指定します。
//辞書データに存在しない言語の文字は指定しないでください。
//
//$twf
//0: HTML
//1: 1行にしてHTMLタグを削除。(ツイッターなど)
//
//$yaku_cut:
//0: 訳語カットしない。
//1: 行単位で訳語をカットする。(行単位。一行ならカットしない)
//
//$yakugo_cut_size:
//訳語カットサイズ。
//
//$file1: データのファイル名を指定(鍋田CGIデータファイル)
Function nabeta_random($gengo,$twf,$yaku_cut,$yakugo_cut_size,$file1)
{     
  //ランダム
  global $DATA;
  global $data_version_code;
  global $rec_suu;
  global $index_kaishi_ichi;
  global $data_kaishi_ichi;

  if(($DATA = fopen($file1,"rb"))==FALSE){
    print("Data file $file1 Open Error\n");
    exit(1);
  } 
  $zens = "";
  #ヘッダ読み込み
  hedda_yomikomi($file1);
  if($rec_suu >= 1){
    //データ件数が一件以上。
  {
    $gcnt = 0;
    while(1){
      $seikai_no = rand(0,$rec_suu-1);
      $tangos = tango_yomikomi($seikai_no);
      if(str_gengo_check($tangos,$gengo) > 0){
        break;
      }
      $gcnt++;
      if($gcnt > 200){
        print "Error: no such charcter code.(gengo=$gengo)<br>\n";
	break;
      }
    }

  }
	  

    if(strcmp($tangos,"")==0){
      #単語名がない。エラー
    }
    else{
      $yakugo = "";
      while (1){
        $c = fgetc($DATA);
        if(strcmp($c,"\0")==0){
          break;
        }
        $yakugo = $yakugo . $c; 
      }
      $yakugo = yakugo_syori($yakugo,$twf,$yaku_cut,$yakugo_cut_size);
      if($twf){
        $yakugo = strip_tags($yakugo);
        $zens = $tangos . " : " . $yakugo;
      }
      else{
        $zens = $tangos . "<br>" . $yakugo;
      }
    }
  }
  fclose($DATA);
  return $zens;
}

?>
